/*
**	NOTEDEFS.H
**	Definitions of pitch classes & MIDI key names
*/

/* pitch classes */
#define	C		0
#define	Db		1
#define	D		2
#define	Ds		3
#define	Eb		3
#define	E		4
#define	F		5
#define	Fs		6
#define	Gb		6
#define	G		7
#define	Gs		8
#define	Ab		8
#define	A		9
#define	As		10
#define	Bb		10
#define	B		11
/* changed to make middle C be "C3", 5/89 */
#define	_n(x,y)		(x + (y + 2) * 12)

/* MIDI key numbers */
#define	C_2	_n(C,-2)
#define	Cs_2	_n(Cs,-2)
#define	Db_2	_n(Db,-2)
#define	D_2	_n(D,-2)
#define	Ds_2	_n(Ds,-2)
#define	Eb_2	_n(Eb,-2)
#define	E_2	_n(E,-2)
#define	F_2	_n(F,-2)
#define	Fs_2	_n(Fs,-2)
#define	Gb_2	_n(Gb,-2)
#define	G_2	_n(G,-2)
#define	Gs_2	_n(Gs,-2)
#define	Ab_2	_n(Ab,-2)
#define	A_2	_n(A,-2)
#define	As_2	_n(As,-2)
#define	Bb_2	_n(Bb,-2)
#define	B_2	_n(B,-2)
#define	C_1	_n(C,-1)
#define	Cs_1	_n(Cs,-1)
#define	Db_1	_n(Db,-1)
#define	D_1	_n(D,-1)
#define	Ds_1	_n(Ds,-1)
#define	Eb_1	_n(Eb,-1)
#define	E_1	_n(E,-1)
#define	F_1	_n(F,-1)
#define	Fs_1	_n(Fs,-1)
#define	Gb_1	_n(Gb,-1)
#define	G_1	_n(G,-1)
#define	Gs_1	_n(Gs,-1)
#define	Ab_1	_n(Ab,-1)
#define	A_1	_n(A,-1)
#define	As_1	_n(As,-1)
#define	Bb_1	_n(Bb,-1)
#define	B_1	_n(B,-1)
#define	C0	_n(C,0)
#define	Cs0	_n(Cs,0)
#define	Db0	_n(Db,0)
#define	D0	_n(D,0)
#define	Ds0	_n(Ds,0)
#define	Eb0	_n(Eb,0)
#define	E0	_n(E,0)
#define	F0	_n(F,0)
#define	Fs0	_n(Fs,0)
#define	Gb0	_n(Gb,0)
#define	G0	_n(G,0)
#define	Gs0	_n(Gs,0)
#define	Ab0	_n(Ab,0)
#define	A0	_n(A,0)
#define	As0	_n(As,0)
#define	Bb0	_n(Bb,0)
#define	B0	_n(B,0)
#define	C1	_n(C,1)
#define	Cs1	_n(Cs,1)
#define	Db1	_n(Db,1)
#define	D1	_n(D,1)
#define	Ds1	_n(Ds,1)
#define	Eb1	_n(Eb,1)
#define	E1	_n(E,1)
#define	F1	_n(F,1)
#define	Fs1	_n(Fs,1)
#define	Gb1	_n(Gb,1)
#define	G1	_n(G,1)
#define	Gs1	_n(Gs,1)
#define	Ab1	_n(Ab,1)
#define	A1	_n(A,1)
#define	As1	_n(As,1)
#define	Bb1	_n(Bb,1)
#define	B1	_n(B,1)
#define	C2	_n(C,2)
#define	Cs2	_n(Cs,2)
#define	Db2	_n(Db,2)
#define	D2	_n(D,2)
#define	Ds2	_n(Ds,2)
#define	Eb2	_n(Eb,2)
#define	E2	_n(E,2)
#define	F2	_n(F,2)
#define	Fs2	_n(Fs,2)
#define	Gb2	_n(Gb,2)
#define	G2	_n(G,2)
#define	Gs2	_n(Gs,2)
#define	Ab2	_n(Ab,2)
#define	A2	_n(A,2)
#define	As2	_n(As,2)
#define	Bb2	_n(Bb,2)
#define	B2	_n(B,2)
#define	C3	_n(C,3)
#define	Cs3	_n(Cs,3)
#define	Db3	_n(Db,3)
#define	D3	_n(D,3)
#define	Ds3	_n(Ds,3)
#define	Eb3	_n(Eb,3)
#define	E3	_n(E,3)
#define	F3	_n(F,3)
#define	Fs3	_n(Fs,3)
#define	Gb3	_n(Gb,3)
#define	G3	_n(G,3)
#define	Gs3	_n(Gs,3)
#define	Ab3	_n(Ab,3)
#define	A3	_n(A,3)
#define	As3	_n(As,3)
#define	Bb3	_n(Bb,3)
#define	B3	_n(B,3)
#define	C4	_n(C,4)
#define	Cs4	_n(Cs,4)
#define	Db4	_n(Db,4)
#define	D4	_n(D,4)
#define	Ds4	_n(Ds,4)
#define	Eb4	_n(Eb,4)
#define	E4	_n(E,4)
#define	F4	_n(F,4)
#define	Fs4	_n(Fs,4)
#define	Gb4	_n(Gb,4)
#define	G4	_n(G,4)
#define	Gs4	_n(Gs,4)
#define	Ab4	_n(Ab,4)
#define	A4	_n(A,4)
#define	As4	_n(As,4)
#define	Bb4	_n(Bb,4)
#define	B4	_n(B,4)
#define	C5	_n(C,5)
#define	Cs5	_n(Cs,5)
#define	Db5	_n(Db,5)
#define	D5	_n(D,5)
#define	Ds5	_n(Ds,5)
#define	Eb5	_n(Eb,5)
#define	E5	_n(E,5)
#define	F5	_n(F,5)
#define	Fs5	_n(Fs,5)
#define	Gb5	_n(Gb,5)
#define	G5	_n(G,5)
#define	Gs5	_n(Gs,5)
#define	Ab5	_n(Ab,5)
#define	A5	_n(A,5)
#define	As5	_n(As,5)
#define	Bb5	_n(Bb,5)
#define	B5	_n(B,5)
#define	C6	_n(C,6)
#define	Cs6	_n(Cs,6)
#define	Db6	_n(Db,6)
#define	D6	_n(D,6)
#define	Ds6	_n(Ds,6)
#define	Eb6	_n(Eb,6)
#define	E6	_n(E,6)
#define	F6	_n(F,6)
#define	Fs6	_n(Fs,6)
#define	Gb6	_n(Gb,6)
#define	G6	_n(G,6)
#define	Gs6	_n(Gs,6)
#define	Ab6	_n(Ab,6)
#define	A6	_n(A,6)
#define	As6	_n(As,6)
#define	Bb6	_n(Bb,6)
#define	B6	_n(B,6)
#define	C7	_n(C,7)
#define	Cs7	_n(Cs,7)
#define	Db7	_n(Db,7)
#define	D7	_n(D,7)
#define	Ds7	_n(Ds,7)
#define	Eb7	_n(Eb,7)
#define	E7	_n(E,7)
#define	F7	_n(F,7)
#define	Fs7	_n(Fs,7)
#define	Gb7	_n(Gb,7)
#define	G7	_n(G,7)
#define	Gs7	_n(Gs,7)
#define	Ab7	_n(Ab,7)
#define	A7	_n(A,7)
#define	As7	_n(As,7)
#define	Bb7	_n(Bb,7)
#define	B7	_n(B,7)
#define	C8	_n(C,8)
#define	Cs8	_n(Cs,8)
#define	Db8	_n(Db,8)
#define	D8	_n(D,8)
#define	Ds8	_n(Ds,8)
#define	Eb8	_n(Eb,8)
#define	E8	_n(E,8)
#define	F8	_n(F,8)
#define	Fs8	_n(Fs,8)
#define	Gb8	_n(Gb,8)
#define	G8	_n(G,8)
